﻿import as.*;
class RingFormation {
	var fps:Number = 30;
	var komaList:Array;
	var kakudoList:Array;
	var heikinKakudoList:Array;
	var bigScale:Number;
	var smallScale:Number;
	//
	var stageCenter:Object;
	var stageSidePoint:Object;
	var stageRightSide:Object;
	var stageLeftSide:Object;
	var centerPoint:Object;
	var currentCenter:Object;
	//
	var circleR:Number;
	var currentR:Number;
	//
	var offsetKakudo:Number;
	var heikinKakudo:Number;
	var bigKakudo:Number;
	var smallKakudo:Number;
	var easeKakudo:Number;
	//軸の傾き角度
	var katamuki:Number;
	//楕円の比率（y/x)
	var daenhi:Number;
	//角速度（度数）
	var rotateSpeed:Number = 0;
	//カレントになっているコマのno（0からスタート）
	var currentKomaNo:Number;
	//var currentKomaScale:Number;
	//直前にカレントだったコマ
	var prevCurrentKomaNo:Number = -1;
	//var prevCurrentKomaScale:Number = 100;
	//回転しなければならない角度
	var howLong:Number = 0;
	//回転した角度
	var howTrip:Number = 0;
	//
	var allDone:Boolean = true;
	var stepFrames:Number = 0;
	var smallShrinkSpeed:Number = 0;
	var bigShrinkSpeed:Number = 0;
	//タイマー
	var expandStepTimer:Number;
	var shrinkStepTimer:Number;
	var rotateStepTimer:Number;
	//
	var bigBallScale:Number;
	//コンストラクタ
	function RingFormation(mcs:Array, startNo:Number) {
		initVariable(mcs, startNo);
	}
	//初期値の設定
	function initVariable(mcs:Array, startNo:Number) {
		komaList = mcs;
		//ピクセル数
		var bigSize:Number = 360;
		var smallSize:Number = 100;
		//パーセント
		bigScale = Math.round(bigSize/smallSize*100);
		smallScale = Math.min(120, Math.max(50, 100*(10/komaList.length)));
		//平均角度
		heikinKakudo = Math.round(360/komaList.length);
		//大きいコマが使用する角度（度数）
		if (komaList.length<5) {
			bigKakudo = heikinKakudo*1.2;
		} else if (komaList.length<10) {
			bigKakudo = 120;
		} else if (komaList.length<15) {
			bigKakudo = 100;
		} else {
			bigKakudo = 90;
		}
		smallKakudo = (360-bigKakudo)/(komaList.length-2);
		//各ポジションの角度を設定する（これは回転しても変化しないのだ！）
		kakudoList = new Array();
		heikinKakudoList = new Array();
		//スタートの角度
		offsetKakudo = 80;
		kakudoList[0] = offsetKakudo;
		heikinKakudoList[0] = offsetKakudo;
		for (var i = 1; i<komaList.length; i++) {
			var kakudo = offsetKakudo+bigKakudo/2+smallKakudo*(i-1);
			kakudoList[i] = Math.round(kakudo%360);
			heikinKakudoList[i] = offsetKakudo+heikinKakudo/2+heikinKakudo*(i-1);
			//trace(kakudoList.toString());
			//trace(heikinKakudoList.toString())
		}
		for (var i = 0; i<komaList.length; i++) {
			var targetMC = komaList[i];
			//mcへのダイナミックなプロパティ
			targetMC["myPos"] = i;
			targetMC["myKakudo"] = kakudoList[i];
			targetMC["tmpKakudo"] = kakudoList[i];
		}
		//trace([bigKakudo,smallKakudo, kakudoList.toString()])
		//円の中心座標
		var cx = Stage.width/2-30;
		var cy = Stage.height/2-30;
		stageCenter = {x:cx, y:cy};
		var srx = Stage.width-50;
		var sry = Stage.height-50;
		stageRightSide = {x:srx, y:sry};
		stageLeftSide = {x:50, y:sry};
		//半径
		currentR = circleR=350;
		//楕円の比率（y/x)
		daenhi = 0.6;
		//daenhi =1;
		//軸の傾き角度
		katamuki = -30*Math.PI/180;
		//katamuki = 0;
		currentKomaNo = startNo;
		prevCurrentKomaNo = startNo;
	}
	//
	function getKakudoToPoint(kakudo:Number, r:Number, center:Object):Object {
		var point = new Object();
		var x = r*Math.cos(kakudo*Math.PI/180);
		var y = r*Math.sin(kakudo*Math.PI/180)*daenhi;
		//軸を傾ける
		point.x = x*Math.cos(katamuki)-y*Math.sin(katamuki)+center.x;
		point.y = x*Math.sin(katamuki)+y*Math.cos(katamuki)+center.y;
		//
		return point;
	}
	//座標から角度を調べる------楕円に適応していない？？
	//使わないかもしれない....
	//function getPointToKakudo(point:Object):Number {
	//var x = point.x-stageCenter.x;
	//var y = point.y-stageCenter.y;
	//var kakudo = Math.floor((Math.atan2(y, x)*180/Math.PI))-offsetKakudo;
	//return kakudo;
	//}
	//for test
	/*
						function test(no:Number) {
							centerPoint = stageCenter;
							var r = 100;
							for (var i = 0; i<komaList.length; i++) {
								var targetMC:MovieClip = komaList[i];
								var kakudo:Number = kakudoList[i];
								var point:Object = getKakudoToPoint(kakudo, r, centerPoint);
								targetMC._x = point.x;
								targetMC._y = point.y;
								if (i == no) {
									targetMC._xscale = targetMC._yscale=bigScale;
								} else {
									targetMC._xscale = targetMC._yscale=smallScale;
								}
							}
						}
						*/
	//
	// Formation Method
	//
	//回転して広がって登場
	//mcsは事前にできていることを前提としている
	function expandRing(startPoint:Object) {
		if (allDone == false) {
			return;
		}
		//
		clearInterval(rotateStepTimer);
		clearInterval(shrinkStepTimer);
		clearInterval(expandStepTimer);
		//
		currentCenter = stageRightSide;
		currentR = 0;
		easeKakudo = 0;
		howTrip = 0;
		howLong = 360;
		allDone = false;
		expandStepTimer = setInterval(this, "expandStep", 1000/fps);
	}
	//
	function expandStep() {
		if (allDone == true) {
			trace("done");
			clearInterval(expandStepTimer);
		} else {
			//中心移動、半径、回転角度
			allDone = true;
			currentCenter = getEasePoint(currentCenter, stageCenter);
			currentR = getEaseR(currentR, circleR, 10);
			howTrip = easeKakudo=getEaseKakudo(easeKakudo, 360, 10);
			//trace([currentCenter,currentR,easeKakudo]);
			//
			for (var i = 0; i<komaList.length; i++) {
				var targetMC:MovieClip = komaList[i];
				var kakudo:Number = kakudoList[i]+easeKakudo;
				var point:Object = getKakudoToPoint(kakudo, currentR, currentCenter);
				targetMC._x = point.x;
				targetMC._y = point.y;
				if (i == currentKomaNo) {
					var scale = getEaseScale(targetMC._xscale, bigScale, 10);
					targetMC._xscale = targetMC._yscale=scale;
				} else {
					var scale = getEaseScale(targetMC._xscale, smallScale, 10);
					targetMC._xscale = targetMC._yscale=scale;
				}
				//
				var scope = this;
				targetMC["no"] = i;
				targetMC.onPress = function() {
					scope.hitKoma(this.no);
					//trace(this.no);
				};
			}
		}
	}
	/////////////////////////////////////
	//回転して縮まって控える
	function shrink(side:String) {
		clearInterval(rotateStepTimer);
		clearInterval(shrinkStepTimer);
		clearInterval(expandStepTimer);
		//
		if (side == "left") {
			stageSidePoint = stageLeftSide;
		} else {
			stageSidePoint = stageRightSide;
		}
		easeKakudo = 0;
		howTrip = 0;
		howLong = 360;
		allDone = false;
		shrinkStepTimer = setInterval(this, "shrinkStep", 1000/fps);
	}
	//
	function shrinkStep() {
		if (allDone == true) {
			trace("done");
			clearInterval(shrinkStepTimer);
		} else {
			//中心移動、半径、回転角度
			allDone = true;
			currentCenter = getEasePoint(currentCenter, stageSidePoint);
			currentR = getEaseR(currentR, 1, 5);
			easeKakudo = getEaseKakudo(easeKakudo, 360, 10);
			//
			for (var i = 0; i<komaList.length; i++) {
				var targetMC:MovieClip = komaList[i];
				var kakudo:Number = kakudoList[i]+easeKakudo;
				var point:Object = getKakudoToPoint(kakudo, currentR, currentCenter);
				targetMC._x = point.x;
				targetMC._y = point.y;
				var scale = getEaseScale(targetMC._xscale, smallScale, 5);
				targetMC._xscale = targetMC._yscale=scale;
			}
		}
	}
	/////////////////////////////////////
	//コマをクリック
	function hitKoma(no:Number) {
		centerPoint = stageCenter;
		currentCenter = stageCenter;
		//移動する角度を求める
		var farCnt:Number = currentKomaNo-no;
		farCnt = no>currentKomaNo ? komaList.length+farCnt : farCnt;
		if (farCnt == 0) {
			howLong = 0;
		} else if (farCnt == 1) {
			howLong = Math.round(bigKakudo/2);
		} else {
			howLong = Math.round(bigKakudo/2+smallKakudo*(farCnt-1));
		}
		howTrip = 0;
		//
		smallShrinkSpeed = 0;
		bigShrinkSpeed = 0;
		rotateSpeed = 0;
		prevCurrentKomaNo = currentKomaNo;
		currentKomaNo = no;
		//回転スタート
		rotationStart();
	}
	//
	//回転アニメーション
	//回転開始
	function rotationStart() {
		clearInterval(rotateStepTimer);
		clearInterval(shrinkStepTimer);
		clearInterval(expandStepTimer);
		//
		stepFrames = 0;
		allDone = false;
		rotateStepTimer = setInterval(this, "rotateStep", 1000/fps);
	}
	//
	function rotateStep() {
		if (allDone == true) {
			trace("done");
			clearInterval(rotateStepTimer);
		} else {
			stepFrames++;
			rotate();
		}
	}
	//回転処理
	function rotate() {
		if (howLong>60) {
			if ((howTrip/howLong)<0.8) {
				smallShrinkSpeed += 0.8;
				bigShrinkSpeed += 0.1;
				rotateSpeed += 0.5;
			} else if ((howTrip/howLong)<0.85) {
				smallShrinkSpeed += 0.7;
				bigShrinkSpeed += 0.8;
				rotateSpeed += 0.4;
			} else {
				smallShrinkSpeed += 0.8;
				bigShrinkSpeed += 2;
				rotateSpeed += 2;
			}
		} else {
			smallShrinkSpeed += 0.8;
			bigShrinkSpeed += 0.3;
			rotateSpeed += 0.4;
		}
		//
		allDone = true;
		//
		currentCenter = getEasePoint(currentCenter, centerPoint);
		currentR = getEaseR(currentR, circleR, 10);
		//
		for (var i = 0; i<komaList.length; i++) {
			var targetMC:MovieClip = komaList[i];
			//各コマの自身のゴールno
			var goalNo:Number = i>=currentKomaNo ? i-currentKomaNo : komaList.length+(i-currentKomaNo);
			if ((howLong>200) && (howTrip/howLong<0.5)) {
				var goalKakudo:Number = heikinKakudoList[goalNo];
				//var goalKakudo:Number = kakudoList[goalNo];
			} else {
				var goalKakudo:Number = kakudoList[goalNo];
			}
			var myKakudo = targetMC["myKakudo"];
			var distance:Number = goalKakudo>myKakudo ? (goalKakudo-myKakudo) : (360+goalKakudo-myKakudo);
			if (distance%360 != 0) {
				if (Math.abs(distance)>0.1) {
					var tmpDistance = distance*Math.sin(rotateSpeed*Math.PI/180);
					var tmpMyKakudo = myKakudo+tmpDistance;
					//var tmpMyKakudo = myKakudo+distance/5;
					if (i == currentKomaNo) {
						howTrip += tmpDistance;
						howTrip = Math.round(howTrip);
					}
					allDone = false;
				} else {
					var tmpMyKakudo = goalKakudo;
				}
				var tmpMyKakudo = tmpMyKakudo%360;
				targetMC["myKakudo"] = tmpMyKakudo;
				//位置決め
				var bigMC = komaList[currentKomaNo];
				var point:Object = getKakudoToPoint(tmpMyKakudo, currentR, currentCenter);
				targetMC._x = point.x;
				targetMC._y = point.y;
			}
			//スケール調整
			var myScale:Number = targetMC._xscale;
			if (i == currentKomaNo) {
				var bigBallScale:Number = myScale+(bigScale-myScale)*Math.sin(bigShrinkSpeed*Math.PI/180);
				targetMC._xscale = targetMC._yscale=bigBallScale;
				if (Math.abs(bigScale-myScale)<2) {
					targetMC._xscale = targetMC._yscale=bigScale;
				} else {
					allDone = false;
				}
			} else {
				var smallBallScale:Number = myScale+(smallScale-myScale)*Math.sin(smallShrinkSpeed*Math.PI/180);
				targetMC._xscale = targetMC._yscale=smallBallScale;
				if (Math.abs(smallScale-myScale)<2) {
					targetMC._xscale = targetMC._yscale=smallScale;
				} else {
					allDone = false;
				}
			}
			//
		}
	}
	///////////////////////////////////////
	//ease
	//点の移動
	function getEasePoint(currentPoint:Object, goalPoint:Object):Object {
		var tmpX:Number = Math.abs(goalPoint.x-currentPoint.x);
		var tmpY:Number = Math.abs(goalPoint.y-currentPoint.y);
		if ((howTrip/howLong)<0.5) {
			var f = 10;
		} else {
			var f = 5;
		}
		if ((tmpX<0.1) && (tmpY<0.1)) {
			currentPoint = goalPoint;
		} else {
			currentPoint.x += (goalPoint.x-currentPoint.x)/f;
			currentPoint.y += (goalPoint.y-currentPoint.y)/f;
			allDone = false;
		}
		return currentPoint;
	}
	//回転半径
	function getEaseR(currentValue:Number, goalValue:Number, f:Number):Number {
		return getEaseValue(currentValue, goalValue, f);
	}
	//回転角度
	function getEaseKakudo(currentValue:Number, goalValue:Number, f:Number):Number {
		return getEaseValue(currentValue, goalValue, f);
	}
	//スケール
	function getEaseScale(currentValue:Number, goalValue:Number, f:Number):Number {
		return getEaseValue(currentValue, goalValue, f);
	}
	//イーズ計算
	function getEaseValue(currentValue:Number, goalValue:Number, f:Number):Number {
		var tmpS:Number = Math.abs(goalValue-currentValue);
		if (tmpS<0.1) {
			currentValue = goalValue;
		} else {
			currentValue += (goalValue-currentValue)/f;
			allDone = false;
		}
		return currentValue;
	}
	//角度をラジアンに変換
	function degToRad(degrees:Number) {
		var radians:Number = degrees*Math.PI/180;
		return radians;
	}
}
